integrations.sh
← all integrations

Airflow API (Stable)

OpenAPI apis-guru messaging

Overview

To facilitate management, Apache Airflow supports a range of REST API endpoints across its objects. This section provides an overview of the API design, methods, and supported use cases.

Most of the endpoints accept JSON as input and return JSON responses. This means that you must usually add the following headers to your request:

Content-type: application/jsonAccept: application/json

Resources

The term resource refers to a single type of object in the Airflow metadata. An API is broken up by its endpoint's corresponding resource. The name of a resource is typically plural and expressed in camelCase. Example: dagRuns.

Resource names are used as part of endpoint URLs, as well as in API parameters and responses.

CRUD Operations

The platform supports Create, Read, Update, and Delete operations on most resources. You can review the standards for these operations and their standard parameters below.

Some endpoints have special behavior as exceptions.

Create

To create a resource, you typically submit an HTTP POST request with the resource's required metadata in the request body. The response returns a 201 Created response code upon success with the resource's metadata, including its internal id, in the response body.

Read

The HTTP GET request can be used to read a resource or to list a number of resources.

A resource's id can be submitted in the request parameters to read a specific resource. The response usually returns a 200 OK response code upon success, with the resource's metadata in the response body.

If a GET request does not include a specific resource id, it is treated as a list request. The response usually returns a 200 OK response code upon success, with an object containing a list of resources' metadata in the response body.

When reading resources, some common query parameters are usually available. e.g.:

v1/connections?limit=25&offset=25
Query ParameterTypeDescription
limitintegerMaximum number of objects to fetch. Usually 25 by default
offsetintegerOffset after which to start returning objects. For use with limit query parameter.

Update

Updating a resource requires the resource id, and is typically done using an HTTP PATCH request, with the fields to modify in the request body. The response usually returns a 200 OK response code upon success, with information about the modified resource in the response body.

Delete

Deleting a resource requires the resource id and is typically executing via an HTTP DELETE request. The response usually returns a 204 No Content response code upon success.

Conventions

  • Resource names are plural and expressed in camelCase.

  • Names are consistent between URL parameter name and field name.

  • Field names are in snake_case.

json
{    "name": "string",    "slots": 0,    "occupied_slots": 0,    "used_slots": 0,    "queued_slots": 0,    "open_slots": 0}

Update Mask

Update mask is available as a query parameter in patch endpoints. It is used to notify the API which fields you want to update. Using update_mask makes it easier to update objects by helping the server know which fields to update in an object instead of updating all fields. The update request ignores any fields that aren't specified in the field mask, leaving them with their current values.

Example:

  resource = request.get('/resource/my-id').json()  resource['my_field'] = 'new-value'  request.patch('/resource/my-id?update_mask=my_field', data=json.dumps(resource))

Versioning and Endpoint Lifecycle

  • API versioning is not synchronized to specific releases of the Apache Airflow.
  • APIs are designed to be backward compatible.
  • Any changes to the API will first go through a deprecation phase.

Trying the API

You can use a third party client, such as , , or to test the Apache Airflow API.

Note that you will need to pass credentials data.

For e.g., here is how to pause a DAG with , when basic authorization is used:

bash
curl -X PATCH 'https://example.com/api/v1/dags/{dag_id}?update_mask=is_paused' \-H 'Content-Type: application/json' \--user "username:password" \-d '{    "is_paused": true}'

Using a graphical tool such as or , it is possible to import the API specifications directly:

  1. Download the API specification by clicking the Download button at top of this document
  2. Import the JSON specification in the graphical tool of your choice.
  • In Postman, you can click the import button at the top
  • With Insomnia, you can just drag-and-drop the file on the UI

Note that with Postman, you can also generate code snippets by selecting a request and clicking on the Code button.

Enabling CORS

is a browser security feature that restricts HTTP requests that are initiated from scripts running in the browser.

For details on enabling/configuring CORS, see .

Authentication

To be able to meet the requirements of many organizations, Airflow supports many authentication methods, and it is even possible to add your own method.

If you want to check which auth backend is currently set, you can use airflow config get-value api auth_backends command as in the example below.

bash
$ airflow config get-value api auth_backendsairflow.api.auth.backend.basic_auth

The default is to deny all requests.

For details on configuring the authentication, see .

Errors

We follow the error response format proposed in also known as Problem Details for HTTP APIs. As with our normal API responses, your client must be prepared to gracefully handle additional members of the response.

Unauthenticated

This indicates that the request has not been applied because it lacks valid authentication credentials for the target resource. Please check that you have valid credentials.

PermissionDenied

This response means that the server understood the request but refuses to authorize it because it lacks sufficient rights to the resource. It happens when you do not have the necessary permission to execute the action you performed. You need to get the appropriate permissions in other to resolve this error.

BadRequest

This response means that the server cannot or will not process the request due to something that is perceived to be a client error (e.g., malformed request syntax, invalid request message framing, or deceptive request routing). To resolve this, please ensure that your syntax is correct.

NotFound

This client error response indicates that the server cannot find the requested resource.

MethodNotAllowed

Indicates that the request method is known by the server but is not supported by the target resource.

NotAcceptable

The target resource does not have a current representation that would be acceptable to the user agent, according to the proactive negotiation header fields received in the request, and the server is unwilling to supply a default representation.

AlreadyExists

The request could not be completed due to a conflict with the current state of the target resource, e.g. the resource it tries to create already exists.

Unknown

This means that the server encountered an unexpected condition that prevented it from fulfilling the request.

Homepage
https://api.apis.guru/v2/specs/apache.org/2.5.1.json
Provider
apache.org
OpenAPI version
3.0.3
Spec (JSON)
https://api.apis.guru/v2/specs/apache.org/2.5.1/openapi.json
Spec (YAML)
https://api.apis.guru/v2/specs/apache.org/2.5.1/openapi.yaml

Tools (75)

Extracted live via the executor SDK.

  • config.getConfig

    Get current configuration

  • connection.deleteConnection

    Delete a connection

  • connection.getConnection

    Get a connection

  • connection.getConnections

    List connections

  • connection.patchConnection

    Update a connection

  • connection.postConnection

    Create a connection

  • connection.testConnection

    Test a connection.

    New in version 2.2.0

  • dag.deleteDag

    Deletes all metadata related to the DAG, including finished DAG Runs and Tasks. Logs are not deleted. This action cannot be undone.

    New in version 2.2.0

  • dag.getDag

    Presents only information available in database (DAGModel). If you need detailed information, consider using GET /dags/{dag_id}/details.

  • dag.getDagDetails

    The response contains many DAG attributes, so the response can be large. If possible, consider using GET /dags/{dag_id}.

  • dag.getDags

    List DAGs in the database. dag_id_pattern can be set to match dags of a specific pattern

  • dag.getDagSource

    Get a source code using file token.

  • dag.getTask

    Get simplified representation of a task

  • dag.getTasks

    Get tasks for DAG

  • dag.patchDag

    Update a DAG

  • dag.patchDags

    Update DAGs of a given dag_id_pattern using UpdateMask. This endpoint allows specifying ~ as the dag_id_pattern to update all DAGs. New in version 2.3.0

  • dag.postClearTaskInstances

    Clears a set of task instances associated with the DAG for a specified date range.

  • dag.postSetTaskInstancesState

    Updates the state for multiple task instances simultaneously.

  • dagRun.clearDagRun

    Clear a DAG run.

    New in version 2.4.0

  • dagRun.deleteDagRun

    Delete a DAG run

  • dagRun.getDagRun

    Get a DAG run

  • dagRun.getDagRuns

    This endpoint allows specifying ~ as the dag_id to retrieve DAG runs for all DAGs.

  • dagRun.getDagRunsBatch

    This endpoint is a POST to allow filtering across a large number of DAG IDs, where as a GET it would run in to maximum HTTP request URL length limit.

  • dagRun.getUpstreamDatasetEvents

    Get datasets for a dag run.

    New in version 2.4.0

  • dagRun.postDagRun

    Trigger a new DAG run

  • dagRun.setDagRunNote

    Update the manual user note of a DagRun.

    New in version 2.5.0

  • dagRun.updateDagRunState

    Modify a DAG run.

    New in version 2.2.0

  • dagWarning.getDagWarnings

    List dag warnings

  • dataset.getDataset

    Get a dataset by uri.

  • dataset.getDatasetEvents

    Get dataset events

  • dataset.getDatasets

    List datasets

  • eventLog.getEventLog

    Get a log entry

  • eventLog.getEventLogs

    List log entries from event log.

  • importError.getImportError

    Get an import error

  • importError.getImportErrors

    List import errors

  • monitoring.getHealth

    Get the status of Airflow's metadatabase and scheduler. It includes info about metadatabase and last heartbeat of scheduler.

  • monitoring.getVersion

    Get version information

  • permission.getPermissions

    Get a list of permissions.

    New in version 2.1.0

  • plugin.getPlugins

    Get a list of loaded plugins.

    New in version 2.1.0

  • pool.deletePool

    Delete a pool

  • pool.getPool

    Get a pool

  • pool.getPools

    List pools

  • pool.patchPool

    Update a pool

  • pool.postPool

    Create a pool

  • provider.getProviders

    Get a list of providers.

    New in version 2.1.0

  • role.deleteRole

    Delete a role.

    New in version 2.1.0

  • role.getRole

    Get a role.

    New in version 2.1.0

  • role.getRoles

    Get a list of roles.

    New in version 2.1.0

  • role.patchRole

    Update a role.

    New in version 2.1.0

  • role.postRole

    Create a new role.

    New in version 2.1.0

  • taskInstance.getExtraLinks

    List extra links for task instance.

  • taskInstance.getLog

    Get logs for a specific task instance and its try number.

  • taskInstance.getMappedTaskInstance

    Get details of a mapped task instance.

    New in version 2.3.0

  • taskInstance.getMappedTaskInstances

    Get details of all mapped task instances.

    New in version 2.3.0

  • taskInstance.getTaskInstance

    Get a task instance

  • taskInstance.getTaskInstances

    This endpoint allows specifying ~ as the dag_id, dag_run_id to retrieve DAG runs for all DAGs and DAG runs.

  • taskInstance.getTaskInstancesBatch

    List task instances from all DAGs and DAG runs. This endpoint is a POST to allow filtering across a large number of DAG IDs, where as a GET it would run in to maximum HTTP request URL length limits.

  • taskInstance.patchMappedTaskInstance

    Updates the state for single mapped task instance. New in version 2.5.0

  • taskInstance.patchTaskInstance

    Updates the state for single task instance. New in version 2.5.0

  • taskInstance.setMappedTaskInstanceNote

    Update the manual user note of a mapped Task Instance.

    New in version 2.5.0

  • taskInstance.setTaskInstanceNote

    Update the manual user note of a non-mapped Task Instance.

    New in version 2.5.0

  • user.deleteUser

    Delete a user with a specific username.

    New in version 2.2.0

  • user.getUser

    Get a user with a specific username.

    New in version 2.1.0

  • user.getUsers

    Get a list of users.

    New in version 2.1.0

  • user.patchUser

    Update fields for a user.

    New in version 2.2.0

  • user.postUser

    Create a new user with unique username and email.

    New in version 2.2.0

  • variable.deleteVariable

    Delete a variable

  • variable.getVariable

    Get a variable by key.

  • variable.getVariables

    The collection does not contain data. To get data, you must get a single entity.

  • variable.patchVariable

    Update a variable by key.

  • variable.postVariables

    Create a variable

  • xCom.getXcomEntries

    This endpoint allows specifying ~ as the dag_id, dag_run_id, task_id to retrieve XCOM entries for for all DAGs, DAG runs and task instances. XCom values won't be returned as they can be large. Use this endpoint to get a list of XCom entries and then fetch individual entry to get value.

  • xCom.getXcomEntry

    Get an XCom entry

  • openapi.previewSpec

    Preview an OpenAPI document before adding it as a source

  • openapi.addSource

    Add an OpenAPI source and register its operations as tools